//headders
#include <stdio.h>
#include <string.h>
#include <highgui.h>
#include <cv.h>
#include <cxcore.h>
//cvHoughCirclesp萔
#define METHOD			CV_HOUGH_GRADIENT
#define DP				2
#define HOUGH_PARAM1	100
#define HOUGH_PARAM2	20

void hough_circle(IplImage *src, IplImage *dst , double *dis, double *deg){
	float *p;

	CvMemStorage *storage = cvCreateMemStorage(0);
	CvSeq *circles = NULL;
	
	int i;
	double m,n;

	cvZero(dst);	//o͉摜̏
	//HoughCircle
	circles = cvHoughCircles(src, storage, METHOD, DP, src->height/4, HOUGH_PARAM1, HOUGH_PARAM2, 0, 0);
	
	
	if(circles->total == 1){
		for(i=0; i<100; i++){
			p = (float*)cvGetSeqElem(circles, circles->total);
			cvCircle(dst, cvPoint(cvRound(p[0]), cvRound(p[1])), 3, CV_RGB(255, 255, 255), -1, 8, 0);				//~̒S̒o
			cvCircle(dst, cvPoint(cvRound(p[0]), cvRound(p[1])), cvRound(p[2]), CV_RGB(255, 255, 255), 3, 8, 0);	//~̒o
			//printf("%f \n",p[2]);

			//̌vZ
			m = p[2];
			//*dis = 31.034 * pow(m,-1.2116);
			*dis = 28102*pow(m,-1.102);

			//Ŝ̌vZ
			n = p[0] - 160;
			*deg = 30 * (n/160);
			//*deg = 28102*pow(m,-1.102);
		}
	}
	
	//printf("Err of Distance = %lf [mm],Angle = %lf [deg]\n",*dis,*deg);

	//cvShowImage("HoughCircle", dst);

	return;
}
