//Program option
//#define __NUMR_CV_IO__
//include
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <cxcore.h>
#include <cv.h>
#include <highgui.h>
#include "../include/num_detect_extern.h"
#include "../include/threshold_value.h"
#include "../include/use_window.h"

//STANDERD VALUES
#define HIGH	255
#define LOW		0
#define FONT_COLOR	"black"
//PARAM (MAIN)
#define SLEEP_TIME	10//msec
#define IMAGE_WIDTH		320
#define IMAGE_HEIGHT	240
//PARAM (EDGE)
#define EDGE_OPERATOR_SIZE	5
#define TH_EDGE	70
//PARAM (JUDGE)
#define LABEL_MIN_PIX	100
#define PAPER_MIN_PIX	50
//PARAM (valiableTHRESHOLD)
#define TH_WIDTH		20
/************************************************
*	ʊ֐									*
*		src -> ͉摜(ch1[bin], 8U)			*
*		min_pix -> FsNZ̍ŏl	*
*		(min_pixȏ̃sNZmFꂽ	*
*		ƔF)								*
************************************************/
#include <cxcore.h>
#include "../include/bmp.h"
int isPaper(IplImage *src, int min_pix){
	int i, j;
	int nx=src->width, ny=src->height;
	int counter=0;
	int ret_val=0;
//sNZ̃JEg臒l
	for(i = 0; i < ny; i++){
		for(j = 0; j < nx; j++){
			if(src->imageData[nx*i + j] != LOW) counter++;
		}
	}
//ǂ̔f(̌Ɋ֌WȂŏsNZŔf)
	if(counter > min_pix){
		//ŏsNZȏ̔sNZ݂ΎƔF
		ret_val = 1;
	}
	return(ret_val);
}

/****************************************************
*	xÖ̗݂͉̂摜璊o			*
*		src -> ͉摜(ch1[gray], 8U)				*
*		dst -> o͉摜(ch1[gray], 8U)				*
*		labeling_data -> xÕf[^			*
*		label_num -> oxԍ			*
*		font_color -> ɏꂽ̐F			*
****************************************************/

void labelTrim(	IplImage *src, IplImage *dst,
				short *labeling_data, int label_num,
				char *font_color)
{
	int i, j;
	int nx, ny;
	CvSeq *first_contour = NULL;
	IplImage *temp;
	CvMemStorage *storage = cvCreateMemStorage(0);
//ϐ
	nx = dst->width; ny = dst->height;
	temp = cvCreateImage(cvGetSize(src), IPL_DEPTH_8U, 3);
	cvZero(temp);
	cvZero(dst);
//ox̏ꏊ𔒂ɂ摜̍쐬
	for(i = 0; i < ny; i++){
		for(j = 0; j < nx; j++){
			if(labeling_data[nx*i + j] == label_num){
				dst->imageData[nx*i + j] = HIGH;
			}
		}
	}
//ẍhԂ
	cvFindContours(	dst, storage, &first_contour,
					sizeof(CvContour), CV_RETR_EXTERNAL,
					CV_CHAIN_APPROX_NONE, cvPoint(0, 0));
	cvDrawContours(	temp, first_contour, CV_RGB(HIGH, HIGH, HIGH), CV_RGB(HIGH, HIGH, HIGH), 1, CV_FILLED, 4, cvPoint(0, 0));
	//C[Wo͉摜ɃRs[
	cvSplit(temp, dst, NULL, NULL, NULL);
//hԂꂽꏊɓ͉摜
	for(i = 0; i < ny; i++){
		for(j = 0; j < nx; j++){
			if(dst->imageData[nx*i + j] == LOW){
				if(font_color[0] == 'b' || font_color[0] == 'B'){ dst->imageData[nx*i + j] = HIGH; }
			}else{ dst->imageData[nx*i + j] = src->imageData[nx*i + j]; }
		}
	}
//J
	cvReleaseImage(&temp);
	cvReleaseMemStorage(&storage);
	return;
}

/************************************************
*	ʊ֐									*
*		src -> ƔFꂽ摜(ch1[bin], 8U)	*
*		dist_x -> o͉摜1(ch1[bin], 8U)	*
*		dist_y -> o͉摜2(ch1[bin], 8U)	*
************************************************/

int recognize(IplImage *src, IplImage *dist_x, IplImage *dist_y){
	int i, j;
	int nx, ny;
	int number=-1;
	int line_count=0, pix_count=0;//̃sNZAC̕ێ
	int offset_col=0, offset_row=0;//Ioffsetl
	int max_value=0;
	int row=0, col=0;
	int case_row=0, case_col=0, mode = -1;
	int l1, l2;
	int y1, y2;
	int scan_row;
	int start_row=0, end_row=0, start_col=0, end_col=0, temp_start=0;
	int center_col;
	int thresh_row;
	int counter;
	int offset0 = 3;//ItZbg̍s
	
	int location_row[3], location_col[3];
	int length[3];
	
//ϐ̏
	cvZero(dist_x);
	cvZero(dist_y);
	for(i = 0; i < 3; i++){
		location_row[i] = location_col[i] = length[i] = 0;
	}
	nx = src->width; ny = src->height;
	
//ӕz摜̍쐬
	//y̎ӕz摜̍쐬
	for(i = 0; i < ny; i++){
		counter = 0;
		for(j = 0; j < nx; j++){
			if(src->imageData[nx*i + j] != LOW){
				//ȂsNZƂɎs
				dist_y->imageData[nx*i + counter] = HIGH;//ӕz摜̍쐬
				counter++;//JE^CNg
			}
		}
	}
	//x̎ӕz摜𓯗l̏ō쐬
	for(i = 0; i < nx; i++){
		counter = 0;
		for(j = 0; j < ny; j++){
			if(src->imageData[nx*j + i] != LOW){
				dist_x->imageData[nx*counter + i] = HIGH;
				counter++;
			}
		}
	}
//M̍i
	//y摜̒
	pix_count = 0;
	line_count = 0;
	temp_start = 0;
	max_value = 0;
	if(dist_y->imageData[0] != LOW){
		for(i = 0; i < nx; i++){
			if(dist_y->imageData[i] == LOW){ break; }
			else{ pix_count++; }
		}
		line_count = 1;
	}
	for(i = 1; i < ny; i++){
		if((unsigned char)dist_y->imageData[nx*i]
			- (unsigned char)dist_y->imageData[nx*(i-1)] > 0){
			
			if(pix_count > max_value){
				max_value = pix_count;
				start_row = temp_start;
				end_row = temp_start + line_count;
				offset_col = pix_count/line_count;
			}
			pix_count = 0;
			temp_start = i;
			line_count = 0;
		}
		if(dist_y->imageData[nx*i] != LOW){
			for(j = 0; j < nx; j++){
				if(dist_y->imageData[nx*i + j] == LOW){ break; }
				else{ pix_count++; }
			}
			line_count++;
		}
	}
	if(pix_count > max_value){
		max_value = pix_count;
		start_row = temp_start;
		end_row = temp_start + line_count;
		offset_col = pix_count/line_count;
	}
	offset_col += offset0;
	if(offset_col > nx) offset_col = nx-1;
	//x摜̒
	pix_count = 0;
	line_count = 0;
	temp_start = 0;
	max_value = 0;
	if(dist_x->imageData[0] != LOW){
		for(j = 0; j < ny; j++){
			if(dist_x->imageData[nx*j] == LOW){ break; }
			else{ pix_count++; }
		}
	}
	for(j = 1; j < nx; j++){
		if((unsigned char)dist_x->imageData[j]
			- (unsigned char)dist_x->imageData[j-1] > 0){
			
			if(pix_count > max_value){
				max_value = pix_count;
				start_col = temp_start;
				end_col = temp_start + line_count;
				offset_row = pix_count/line_count;
			}
			pix_count = 0;
			temp_start = j;
			line_count = 0;
		}
		if(dist_x->imageData[j] != LOW){
			for(i = 0; i < ny; i++){
				if(dist_x->imageData[nx*i + j] == LOW){ break; }
				else{ pix_count++; }
			}
			line_count++;
		}
	}
	if(pix_count > max_value){
		max_value = pix_count;
		start_col = temp_start;
		end_col = temp_start + line_count;
		offset_row = pix_count/line_count;
	}
//ItZbglM݂̂𒊏o
	for(i = start_row; i < end_row; i++){
		for(j = 0; j < offset_col; j++){
			dist_y->imageData[nx*i + j] = LOW;
		}
	}
	for(i = start_col; i < end_col; i++){
		for(j = 0; j < offset_row; j++){
			dist_x->imageData[nx*j + i] = LOW;
		}
	}
//M(sNZ)̉
	//x̕z̒
	if(start_row == 0) start_row = 1;
	for(i = start_row; i < end_row; i++){
		if(( (unsigned char)dist_y->imageData[nx*i + offset_col]
			- (unsigned char)dist_y->imageData[nx*(i-1) + offset_col]) > 0){
			//Ỏfƍ̉fƂႤFȂ
			row++;//M̃CNg
			max_value = 0;//݂̐M̍ől
			if(row > 3){ break; }//M̐3ȏゾfor iuCN
		}
		if(dist_y->imageData[nx*i + offset_col] != LOW){
			//MM̒𒲍
			counter = 1;
			for(j = offset_col+1; j < nx; j++){
				if(dist_y->imageData[nx*i + j] != LOW){
					counter++;
				}else{
					break;//sNZ̔for juCN
				}
			}
			if(counter > max_value){
				//M̒̑\l̍XV
				location_row[row - 1] = i;
			}
		}
	}
	//y̕z𓯗lɒ
	if(start_col == 0) start_col = 1;
	for(i = start_col; i < end_col; i++){
		if(( (unsigned char)dist_x->imageData[nx*(offset_row) + i]
			- (unsigned char)dist_x->imageData[nx*(offset_row) + (i-1)]) > 0){
			col++;
			max_value = 0;
			if(col > 2){ break; }//break for_i
		}
		if(dist_x->imageData[nx*(offset_row) + i] != LOW){
			counter = 1;
			for(j = offset_row+1; j < ny; j++){
				if(dist_x->imageData[nx*j + i] != LOW){
					counter++;
				}else{
					break;//break for_j
				}
			}
			if(counter > max_value){
				max_value = counter;
				location_col[col - 1] = i;
				length[col - 1] = max_value;
			}
		}
	}
	
//Mp^[
		//y̐M̃p^[
	if(row > 3) case_col = -1;//p^[O
	case_col = row;//M̐ɂp^[߂
		//x̐M̃p^[
	if(col > 2) case_row = -1;//p^[O
	else if(col == 2){
		//M2ꍇ̔rp^[߂
		l1 = length[0]; l2 = length[1];
		if(l1 > l2){
			if(l1 < l2 + l1/2) case_row = 2;
			else case_row = 1;
		}
		else if(l1 == l2) case_row = 2;
		else if(l1 < l2){
			if(l1 + l2/2 > l2) case_row = 2;
			else case_row = 3;
		}
	}
	else if(col == 1) case_row = 0;
	else if(col == 0) case_row = 4;
//p^[萔𔻒f
	switch(case_row){
		case 0:
			switch(case_col){
				case 0:		number = 1; break;
				case 3:		number = 3; break;
				default:	number = -1; break;
			}
			break;
		case 1:
			switch(case_col){
				case 3:		number = 6; break;
				default:	number = -1; break;
			}
			break;
		case 2:
			switch(case_col){
				case 2:		number = 0; break;
				case 3:		mode = 0; break;
				default:	number = -1; break;
			}
			break;
		case 3:
			switch(case_col){
				case 1:		mode = 1; break;
				case 3:		number = 9; break;
				default:	number = -1; break;
			}
			break;
		case 4:
			switch(case_col){
				case 0:		number = 1; break;
				default:	number = -1; break;
			}
			break;
	}//܂ł0,1,3,6,9͎ʂ
	col = 0;
	if(mode != -1){
		switch(mode){
			case 0://2, 5, 8̎
				//͉摜𒼂ŃX^邱Ƃɂ蔻ʂ݂
				y1 = location_row[0]; y2 = location_row[1];
				center_col = (start_col + end_col)/2;
				scan_row = (y1 + y2)/2;
				//printf("scan_row = %d\n", scan_row);
				for(i = 1; i < nx; i++){
					if((src->imageData[nx*scan_row + i] - src->imageData[nx*scan_row + (i-1)]) < 0){
						col++;
						if(col == 1){
							location_col[0] = i;
						}
					}
				}
				if(col == 0 || col > 2) number = -1;
				else if(col == 2) number = 8;
				else if(col == 1){
					if(location_col[0] > center_col) number = 2;
					else number = 5;
				}
				break;
			case 1://4, 7̎
				//_̈ʒu琄肷
				thresh_row = (3*start_row + end_row)/4;
				if(location_row[0] < thresh_row) number = 7;
				else number = 4;
				break;
			default: number = -1; break;
		}
	}
//̈̕`
	for(i = 0; i < ny; i++)
		for(j = 0; j < nx; j++)
			if(i == start_row-2 || i == end_row+2 || j == start_col-2 || j == end_col+2)src->imageData[nx*i + j] = 150;
//M̏ڍׂ\
/*	for(i = 0; i < 2; i++){
		//printf("\t\tloc_row[%d] = %d\n", i, location_row[i]);
		//printf("\t\tloc_col[%d] = %d\n", i, location_col[i]);
		//printf("\t\tlength_col[%d] = %d\n", i, length[i]);
	}
	//2,5,8y4,7̂Ƃɕ\
	if(mode >= 0) //printf("mode = %d\n", mode);
*/
	return(number);
}

/************************************************
*	ʊ֐									*
*		max_roop_counter -> ő僋[v			*
************************************************/
int num_detect(int max_roop_counter){
	int i, j, k;
	int roop_counter=0;
	int nx=0, ny=0;
	int num_weight[11];
	int max_weight;
	int recog_num=-1;
	int target_num=0, real_target_num=0;
	int label_num=0;
	int *target_area=NULL;
	IplImage 	*inputImage = NULL,
				*grayImage = NULL,
				*laplaceImage = NULL,
				*edgeImage = NULL,
				*col_threImage = NULL,
				*area1Image = NULL,
				*area2Image = NULL,
				*label_dataImage = NULL,
				*trimImage = NULL,
				*resultImage = NULL,
				*xImage = NULL,
				*yImage = NULL;

//EFuJ̉摜̎擾p(vOpenCV֐)
	CvCapture *capture = NULL;
	IplImage *frameImage = NULL;
//uvccapture
	char *filename = "input.jpg";
//L[͔ʗpϐ
	int key;

/******************Program Start*************************/
	key = 0;
	for(i = 0; i < 11; i++){
		num_weight[i] = 0;
	}
#ifdef __NUMR_CV_IO__
//J̒ړIȓ͊\B
	if((capture = cvCreateCameraCapture(CV_CAP_ANY)) == NULL){
		//printf("num_detect: Can't find any camera.\n");
		return -999;
	}
#endif
	while(roop_counter < max_roop_counter || max_roop_counter == -999){
		recog_num = -1;
		roop_counter++;
		if(inputImage == NULL){
			//ϐƂ̏
			inputImage = cvCreateImage(cvSize(IMAGE_WIDTH, IMAGE_HEIGHT), IPL_DEPTH_8U, 3);
			grayImage = cvCreateImage(cvGetSize(inputImage), IPL_DEPTH_8U, 1);
			edgeImage = cvCreateImage(cvGetSize(inputImage), IPL_DEPTH_8U, 1);
			col_threImage = cvCreateImage(cvGetSize(inputImage), IPL_DEPTH_8U, 1);
			area1Image = cvCreateImage(cvGetSize(inputImage), IPL_DEPTH_8U, 1);
			area2Image = cvCreateImage(cvGetSize(inputImage), IPL_DEPTH_8U, 1);
			label_dataImage = cvCreateImage(cvGetSize(inputImage), IPL_DEPTH_16S, 1);
			trimImage = cvCreateImage(cvGetSize(inputImage), IPL_DEPTH_8U, 1);
			resultImage = cvCreateImage(cvGetSize(inputImage), IPL_DEPTH_8U, 1);
			xImage = cvCreateImage(cvGetSize(inputImage), IPL_DEPTH_8U, 1);
			yImage = cvCreateImage(cvGetSize(inputImage), IPL_DEPTH_8U, 1);
			laplaceImage = cvCreateImage(cvGetSize(inputImage), IPL_DEPTH_16S, 1);
			
			nx = inputImage->width; ny = inputImage->height;
			target_area = (int *)malloc(sizeof(int)*nx*ny);
		}
	//摜̎擾
		//printf("get image: start\t");
		if(capture != NULL){
			frameImage = cvQueryFrame(capture);
			if(frameImage == NULL){
				//printf("num_detect: frameImage failed.\n");
				exit(1);
			}
			cvResize(frameImage, inputImage, CV_INTER_NN);
			if(frameImage->origin != 0) cvFlip(inputImage, inputImage, 0);
		}else{
			img_update(filename, IMAGE_WIDTH, IMAGE_HEIGHT);
			if(inputImage != NULL) cvReleaseImage(&inputImage);
			inputImage = cvLoadImage(filename, CV_LOAD_IMAGE_ANYCOLOR);
		}
		//printf("end\n");
	//Fɂ2l
		//printf("obj find: start\t");
		col_threshold(inputImage, col_threImage,
				TARGET_TH1_MIN, TARGET_TH1_MAX,
				TARGET_TH2_MIN, TARGET_TH2_MAX,
				TARGET_TH3_MIN, TARGET_TH3_MAX,
				TARGET_TH_CODE);
		//printf("*");
		if(AREA1_TH_CODE != 0){
			col_threshold(inputImage, area1Image,
				AREA1_TH1_MIN, AREA1_TH1_MAX,
				AREA1_TH2_MIN, AREA1_TH2_MAX,
				AREA1_TH3_MIN, AREA1_TH3_MAX,
				AREA1_TH_CODE);
		}else{
			cvZero(area1Image);
			//printf(" z");
		}
		cvThreshold(area1Image, area1Image, TH_EDGE, HIGH, CV_THRESH_BINARY_INV);
		//printf("*");
		if(AREA2_TH_CODE != 0){
			col_threshold(inputImage, area2Image,
				AREA2_TH1_MIN, AREA2_TH1_MAX,
				AREA2_TH2_MIN, AREA2_TH2_MAX,
				AREA2_TH3_MIN, AREA2_TH3_MAX,
				AREA2_TH_CODE);
		}else{
			cvZero(area2Image);
			//printf(" z");
		}
		cvThreshold(area2Image, area2Image, TH_EDGE, HIGH, CV_THRESH_BINARY_INV);
		//printf("*");
		//printf("end\n");
	//GbWo
		//printf("edge: start\t");
		cvCvtColor(inputImage, grayImage, CV_BGR2GRAY);
		cvSmooth(grayImage, grayImage, CV_MEDIAN, 3, 0, 0, 0);
		cvLaplace(grayImage, laplaceImage, EDGE_OPERATOR_SIZE);
		cvConvertScaleAbs(laplaceImage, edgeImage, 1, 0);
		cvThreshold(edgeImage, edgeImage, TH_EDGE, HIGH, CV_THRESH_BINARY_INV);
		//printf("end\n");
	//̈xO
		//printf("Labeling: start\n");
		cvAnd(edgeImage, area1Image, edgeImage, NULL);
		cvAnd(edgeImage, area2Image, edgeImage, NULL);
		//printf("\tNew edgeImage fin.\n");
		target_num = 0; real_target_num = 0;
		cvZero(label_dataImage);
		for(i = 0; i < ny; i++){
			for(j = 0; j < nx; j++){
				target_area[nx*i + j] = 0;
			}
		}
		//printf("\tZero clear fin.\n");
		for(i = 0; i < ny; i++){
			for(j = 0; j < nx; j++){
				if(col_threImage->imageData[nx*i + j] != LOW
						&& (unsigned char)edgeImage->imageData[nx*i + j] == HIGH){
					target_num = target_num + 1;
					fill(edgeImage, label_dataImage, j, i, target_num);
					fill(edgeImage, edgeImage, j, i, 100);
				}
			}
		}
		//printf("\tLabel(Fill) fin.\n");
		for(i = 0; i < ny; i++){
			for(j = 0; j < nx; j++){
				if((label_num = ((short*)(label_dataImage->imageData))[nx*i + j]) != LOW){
					target_area[label_num-1]++;
				}
			}
		}
		//printf("\tLabel(Area count) fin.\n");
		real_target_num = target_num;
		for(k = 0; k < target_num; k++){
			if(target_area[k] < LABEL_MIN_PIX){
				target_area[k] = 0;
				real_target_num--;
			}
		}
		//printf("\tLabel(Real Area) fin.\n");
		//printf("Labeling: end\n");
		//printf("Recognize: start\n");
		if(real_target_num != 0){
			//printf("\tTarget number = %d\n", real_target_num);
			for(k = 0; k < target_num; k++){
				//printf("%d: ", k+1);
				if(target_area[k] == 0){
					//printf("No\n");
					continue;
				}
				//printf("Storage Clear>>>");
				labelTrim(grayImage, trimImage, (short*)(label_dataImage->imageData), (k+1), FONT_COLOR);
				//printf("Trimming fin>>>");
//				cvThreshold(trimImage, resultImage, PAPER_THRESH, HIGH, CV_THRESH_BINARY);
				val_threshold(trimImage, resultImage, TH_WIDTH, FONT_COLOR);
				//printf("valTh fin\n");
				//printf("\tCheck Obj: ");
				if(isPaper(resultImage, PAPER_MIN_PIX)){
					//printf("YES\n");
					recog_num = recognize(resultImage, xImage, yImage);
					//printf("*********************************\n\n");
					//printf("Number = %d\n", recog_num);
					break;
				}else{
					//printf("NO\n");
				}
			}
			//printf("Check All Target.\n");
		}else{
			//printf("No Target Check\n");
		}
#ifdef __USE_CV_WINDOW__
		//printf("Show Images: start\t");
	//摜\
		cvShowImage(inputIMG, inputImage);
		cvShowImage(labelIMG, edgeImage);
		cvShowImage(threIMG, resultImage);
		//printf("end\n");
		key = cvWaitKey(SLEEP_TIME);
		if(key == 'q' || key == 'Q'){
			break;
		}
#else
		//printf(" usleep ");
		usleep(1000*SLEEP_TIME);
#endif
		//printf("end\n");
		//printf("Loop Fin.*******************************\n");
		//printf("\n");
		if(max_roop_counter != -999)
			num_weight[recog_num + 1]++;
	}//while
//I
	free(target_area);
	cvReleaseImage(&inputImage);
	cvReleaseImage(&grayImage);
	cvReleaseImage(&edgeImage);
	cvReleaseImage(&col_threImage);
	cvReleaseImage(&area1Image);
	cvReleaseImage(&area2Image);
	cvReleaseImage(&label_dataImage);
	cvReleaseImage(&trimImage);
	cvReleaseImage(&resultImage);
	cvReleaseImage(&xImage);
	cvReleaseImage(&yImage);
	cvReleaseImage(&laplaceImage);
	if(capture != NULL)
		cvReleaseCapture(&capture);
	
	max_weight = num_weight[0];
	recog_num = -1;
	//printf("num %d = %d\n", -1, num_weight[0]);
	for(i = 1; i < 11; i++){
	//printf("num %d = %d\n", i-1, num_weight[i]);
		if(num_weight[i] >= max_weight){
			recog_num = i-1;
			max_weight = num_weight[i];
		}
	}
	
	//printf("num_detect: Program Finish!!\n");
	return(recog_num);
}

