#include "midi_no.h"

#define RIGHT 10
#define LEFT 20
#define USS_LOOP 10
#define NUM_TS1 8
#define NUM_TS2 10
#define NUM_TS3 11
#define NUM_TS4 7
#define NUM_WS1 1
#define NUM_WS2 2
#define NUM_WS3 0
#define NUM_WS4 3
#define NUM_WS5 6
//#define NUM_IRS 3

#define F_SPEED 100
#define F_SPEED_MIN 50

#define T_SPEED 100
#define T_SPEED_MIN 50

#define C_SPEED 100
#define C_SPEED_MIN 50

#define DIS_WALL 36
#define DIS_WALL_ROTA 40
#define DIS_KSM 150

#define RADIUS 18//$B@{2sMQ%Q%i%a!<%?(B $B@{2s$7$?$$50F;$NH>7B$r;XDj(B

#define DELAY 100
#define DELAY_ONOFF 10000
#define DELAY_USS 40000
#define DELAY_KEY 100000
#define DELAY_DS 50000
#define M_ERROR 15//$B%?%$%d$N2sE>$KBP$9$k8m:9(B
#define D_ERROR 6

#define WHEEL_RADIUS 63
#define MIRS_RADIUS 330

#define PI 3.14159
#define  TWO_PI 3265//3265//mm

#define ROT_LOOP 250
#define TIME_WAIT 500000

