#include <pthread.h>
#include <termios.h>
#include <sys/ioctl.h>
#include "../include/GV.h"


void *key_thread(){

        char in_char = 0; /* 入力されたキーを保持 */
        char read_byte = 0; /* 読み込んだバイト数 */
        struct termio tty_backup; /* 変更前の設定を保持 */
        struct termio tty_change; /* 変更後の設定を保持 */


        /* 最初に現在の設定を退避します */
        ioctl(0, TCGETA, &tty_backup);
        tty_change = tty_backup;

        /* 設定を変更し、反映させます */
        tty_change.c_lflag &= ~(ECHO | ICANON); /* エコーを止め、RAW モードへ変更 */
        tty_change.c_cc[VMIN] = 0;
        tty_change.c_cc[VTIME] = 1;
        ioctl(0, TCSETAF, &tty_change);

        /*      文字入力                */
        while(in_char != 0x0a){

                read_byte = read(0, &in_char, 1);

			if(read_byte==-1){
				motor_stop2();
				ioctl(0, TCSETAF, &tty_backup);
				fprintf(stderr,"can't read!");
				return;
			}

                switch(in_char){

                case 'e':
			   ioctl(0, TCSETAF, &tty_backup);
			   mirs.end=1;
                        return;
                default:
			   fflush(NULL);
				break;
                	}

		   usleep(DELAY_KEY);
        
        	if(mirs.end==1)pthread_exit(0);
        
        }

}
