#include<cv.h>
#include<highgui.h>
#include<cxcore.h>

#include "./include/CVdefine.h"
#include "./include/CVGV.h"


void threshold(){

	IplImage *inputImage=cvCloneImage(g_capImage);
	IplImage *grayImage,*threImage;

	grayImage=cvCreateImage(cvGetSize(inputImage),IPL_DEPTH_8U,1);
	threImage=cvCreateImage(cvGetSize(inputImage),IPL_DEPTH_8U,1);
	g_threImage=cvCreateImage(cvGetSize(inputImage),IPL_DEPTH_8U,1);

	cvCvtColor(inputImage,grayImage,CV_BGR2GRAY);

	cvThreshold(grayImage,threImage,THRESHOLD,THRESHOLD_MAX,CV_THRESH_BINARY_INV);

	g_threImage=cvCloneImage(threImage);

	cvReleaseImage(&threImage);
	cvReleaseImage(&grayImage);
	cvReleaseImage(&inputImage);

}
