#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <pthread.h>
#include <errno.h>
#include "../include/func_extern.h"
#include "../include/motor.h"
#include "../include/control.h"

pthread_t motor_task;
pthread_attr_t attr_motor;
struct sched_param sched_param;

int main(void){

	char c;
	int val;
	int t;

	printf("mode select\ns:straight\tr:rotate\tc:circle\n\nmode:");
	scanf("%c",&c);
	printf("\nval = \n");
	scanf("%d",&val);
	printf("\ntime = \n");
	scanf("%d",&t);

	//pthread_mutex_init(mutex_m,NULL);

	pthread_attr_init (&attr_motor);
	sched_param.sched_priority = 20;
	pthread_attr_setschedpolicy(&attr_motor, SCHED_RR);
	pthread_attr_setschedparam (&attr_motor, &sched_param);

	printf("opening device...\n");
	fd1 = open(M_PORT_L, O_RDWR);
	if(fd1 < 0){
		if(errno == 3) printf("no such file\n");
		else if(errno == 13) printf("permission\n");
		else printf("other\n");
		fprintf(stderr, "fd1 open error\n");
		exit(-1);
	}
	fd2 = open(M_PORT_R, O_RDWR);
	if(fd2 < 0){
		fprintf(stderr, "fd2 open error\n");
		close(fd1);
		exit(-1);
	}
	printf("end\n");
		
	printf("starting...\n");

	motor(c, val, t);

	printf("end\n");
	
	printf("closing device...\n");
	close(fd1);
	close(fd2);
	printf("end\n");
	printf("Finish!!\n");

	return 0;
}
