#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <termios.h>
#include "../include/func_extern.h"
#include "../include/uss.h"
#include "../include/GV.h"

extern int fd0;

int uss_get(int uss_num){
  unsigned char rs_rbuffer[2];
  unsigned char rs_sbuffer[1];
  int c,x;
  int data = 99999;
  int i=0;
  struct termios oldtio;
  if(uss_num < 0 || uss_num > 4) return(-1);
  memset(rs_rbuffer,'\0',2);
  memset(rs_sbuffer,'\0',1);
  sprintf((char*)rs_sbuffer,"%c",(char)uss_num);

  fd0=open(S_PORT,O_RDWR | O_NOCTTY | O_NONBLOCK);
  if(fd0 <= 0) exit(-1);
  set_serial_port(fd0,&oldtio);

  put_serial_string(fd0,(char*)rs_sbuffer);
  while(1){
    c=0;
    c=get_serial_char(fd0);
	if(uss_read_err==1){
	data=-1;
	return data;
	}
    rs_rbuffer[i] = c;
    i++;
    if(i==2){
	  if(rs_rbuffer[1]==0xff){
		//printf("\"%s\" receive no response\n",S_PORT);
		data = 99999;
		break;
	  }
          c=rs_rbuffer[1];
          x=c<<8;
          c=rs_rbuffer[0];
          data=x+c+20;
//          memset(rs_rbuffer,'\0',2);
          break;
    }
  }
  close_serial_port(fd0,&oldtio);

  return (data);
}
