/********************************************
*	臒l֐						*
*		src -> ͉摜(ch1[gray], 8U)		*
*		dst -> o͉摜(ch1[bin], 8U)		*
*		width -> qXeVX̕			*
*		font_color -> ɏꂽ̐F	*
********************************************/
#include <cxcore.h>
#include <cv.h>
#include "../include/bmp.h"
void val_threshold(IplImage *src, IplImage *dst, int width, char *font_color){
	int i, j;
	int nx = src->width, ny = src->height;
	int th;
	int bg_color, now_color;
	IplImage *temp = cvCreateImage(cvSize(nx, ny), IPL_DEPTH_8U, 1);
	if(font_color[0] == 'b' || font_color[0] == 'B'){
		bg_color = HIGH;
	}else{
		bg_color = LOW;
	}
	for(i = 0; i < ny; i++){
		for(j = 0; j < nx; j++){
			dst->imageData[nx*i + j] = bg_color;
			temp->imageData[nx*i + j] = bg_color;
		}
	}
	for(i = 0; i < ny; i++){
		now_color = bg_color;
		for(j = 1; j < nx; j++){
			if((th=(unsigned char)src->imageData[nx*i + (j-1)]) == bg_color) continue;
			if(now_color == HIGH) th -= width;
			else th += width;
			if((unsigned char)src->imageData[nx*i + j] < th){
				dst->imageData[nx*i + j] = now_color = LOW;
			}else{
				dst->imageData[nx*i + j] = now_color = HIGH;
			}
		}
	}
	for(j = 0; j < nx; j++){
		now_color = bg_color;
		for(i = 1; i < ny; i++){
			if((th=(unsigned char)src->imageData[nx*(i-1) + j]) == bg_color) continue;
			if(now_color == HIGH) th -= width;
			else th += width;
			if((unsigned char)src->imageData[nx*i + j] < th){
				temp->imageData[nx*i + j] = now_color = LOW;
			}else{
				temp->imageData[nx*i + j] = now_color = HIGH;
			}
		}
	}
	if(font_color[0] == 'b' || font_color[0] == 'B'){
		cvThreshold(dst, dst, 100.0, HIGH, CV_THRESH_BINARY_INV);
		cvThreshold(temp, temp, 100.0, HIGH, CV_THRESH_BINARY_INV);
	}
	cvAnd(dst, temp, dst, NULL);
	cvDilate(dst, dst, NULL, 1);
	cvErode(dst, dst, NULL, 1);
	cvReleaseImage(&temp);
	return;
}
