#include "../include/GV.h"

#include <string.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>

int main(int argc,char *argv[]){
	
	int input,kosumo;
	
	if(argc>1)input=atoi(argv[1]);
	else{input=0;}
	
	ini();//初期設定関数
	beep_speed=100;
	mirs.state=-1;	

	ini_onoff_thread();//onoffセンサー監視スレッド
	ini_thread();//センサー&key監視スレッド
	ini_bgm();

	double start,end;
	int func_ret;
	int fps;
	int debug_end;
	int bgmold=0;

	//mirs.rot_r=stddis*lolita('r')-stdrot_r;
	//	mirs.rot_l=stddis*lolita('l')-stdrot_l;
mirs.DBflag=0;
mirs.state=0;
act_normal_speed=50;
	
	//mirs.kosumo=kosumo;
	
	mirs.state=input;

	//mirs.end=1;
	//clearflag=1;

	sleep(1);
	
	while(1){

		if(mirs.end==1){
			motor_stop2();
			
			if(clearflag==1){
				
				sleep(1);
				
				pthread_t bgm_task;
				pthread_create(&bgm_task,NULL,bgm_thread,14);
				
				//bgm_change(14);
				
				motor_rotation(70,RIGHT);
				usleep(700*1000);
				motor_stop2();
				motor_rotation(70,LEFT);
				usleep(350*1000);
				motor_stop2();
				motor_rotation(70,RIGHT);
				usleep(350*1000);
				motor_stop2();
				motor_rotation(70,LEFT);
				usleep(700*1000);
				motor_stop2();
				motor_rotation(70,RIGHT);
				usleep(350*1000);
				motor_stop2();
				motor_rotation(70,LEFT);
				usleep(350*1000);
				motor_rotation(70,RIGHT);
				usleep(3200*1000);
				motor_stop2();
				
			}
			
			return 0;
		}
//if(sensor.lolitaflag==1){
		mirs.rot_r=stddis*lolita('r')-stdrot_r;
		mirs.rot_l=stddis*lolita('l')-stdrot_l;
	
	printf("\nmirs.rot_r=%d\tmirs.rot_l=%d\n",mirs.rot_r,mirs.rot_l);
	
//}
		//mirs.angle_now=0.935*360*((mirs.rot_r-mirs.rot_l)/2)/(MIRS_RADIUS*PI);

		start=gettime();	

		//memset(&flag,0,sizeof(flag));//flagが変わるごとにいちいち1を0にするのがめんどいから一気にやっちゃえと

		

		select_state();//現在状態判断関数
		//////////////
		//mirs.state=-1;
		//////////////
		sensor.ussflag1=1;
		sensor.ussflag2=1;
		sensor.ussflag3=1;
		switch(mirs.state){
			case -1://デバッグ用
			if(turn_left(60,45,5))sleep(3);
			break;
			
			case -2:
				act_bgm();
			break;

			case 0://通路走行行動
				act_normal();
				break;
			
			case 9://白線発見後の動作
				act_hakusen();
				break;
			
			case 10:
				act_DB();//DB読み取り行動
				break;
			
			case 20://ロータリー通過行動
				act_rota();
				break;
			
			case 30://小部屋通行行動
				act_kosumo();
				break;
			
			case 40://行き止まり回避行動
				act_ikidomari();
				break;
			
			case 50://シーソー通過行動
				act_seesaw();
				break;
			
			case 60://ステップ判別・通過行動
				act_step();
				break;
			
			case 70://ゴール通過行動
				act_goal();
				break;
				
			case 80://鍵獲得動作
				act_key();
				break;
			
			default:
				//fprintf(stderr,"mirs.stateの値が不正です\n");
				//return -1;
				break;

		}
		
		if(forward==1){
			if(forward_cnt==forward_cnt_old)forward=0;
		}
		
		forward_cnt_old=forward_cnt;
		
	end=gettime();

	fps=(int)(1.0/(end-start));

	
	print_state(mirs.state);
	
	printf("**********//PRINT_START//*********\n");
	printf("処理時間=%10.20lf sec\n",end-start);
	printf("fps=%d\n",fps);
	printf("angle=%d\n",mirs.angle_now);
	printf("ts1=%c\t ts2=%c\t ts3=%c\t ts4=%c\t ws1=%c\t ws2=%c\n",sensor.ts1,sensor.ts2,sensor.ts3,sensor.ts4,sensor.ws1,sensor.ws2);
	printf("ws3=%c  ws4=%c  ws5=%c\n",sensor.ws3,sensor.ws4,sensor.ws5);
	printf("uss1=%d  uss2=%d  uss3=%d\n",sensor.uss1,sensor.uss2,sensor.uss3);
	printf("ds=%d\n",sensor.ds);
	printf("rot_r=%d\n",mirs.rot_r);
	printf("rot_l=%d\n",mirs.rot_l);
	printf("motor_err=%d\n",motor_err_cnt);
	printf("process=%d\n",mirs.process);
	printf("process_load=%d\n",mirs.process_load);
	printf("process_load_old=%d\n",mirs.process_load_old);
	printf("process_step=%d\n",mirs.process_step);
	printf("process_white=%d\n",mirs.process_white);
	printf("mirs.state=%d\n",mirs.state);
	printf("mirs.state_old=%d\n",mirs.state_old);
	printf("mirs.direction=%d\n", mirs.direction);
	printf("colflag=%d\n",colflag);
	printf("mirs.next_state=%d\n",mirs.next_state);
	printf("mirs.next_dir=%d 10:RIGHT 20:LEFT\n",mirs.next_dir);
	printf("mirs.kosumo=%d 2:LEFT 1:CENTOR 0:RIGHT\n",mirs.kosumo);
	printf("mirs.DBflag=%d\n",mirs.DBflag);
	printf("mirs.rota_deguti=%d 200:RIGHT 400:CENTOR 600:LEFT 800:ENTER\n",mirs.rota_deguti);
	printf("forward=%d\n",forward);
	printf("**********//PRINT_END//*********\n\n");
	
	}

return 0;

}
