#include "../include/GV.h"
#include <math.h>

//前進プログラム

int oldang;

void motor_forward(int speed){
	
	if(collecting2!=13){//collectで前進中はステップフラグは立てない。
	sensor.stepflag=1;
	}

	int nowang=mirs.angle_now;
	
	if(running==0){
		oldang=nowang;
		baseang=nowang;
		running=1;
	}

	if(nowang-oldang>0){
		motor_right('f',speed-4);
		motor_left('f',speed);
	}
	else if(nowang-oldang<0){
		motor_right('f',speed-2);
		motor_left('f',speed);
	}
	else{	
		motor_right('f',speed-3);
		motor_left('f',speed);	
	}
	
	oldang=nowang;
	
}
	
//後退プログラム

void motor_back(int speed){
	sensor.stepflag=0;		
		motor_right('r',speed);
		motor_left('r',speed);
		
		}
		
//停止プログラム

void motor_stop2(){
	sensor.stepflag=0;		
		motor_right('b',0);
		motor_left('b',0);
		//usleep(TIME_WAIT);
			
		}

void motor_rotation(int speed,int muki){
	sensor.stepflag=0;		
		char right,left;

		if(muki==LEFT){
				right='f';
				left='r';
				}
		else if(muki==RIGHT){
				right='r';
				left='f';
				}

		motor_right(right,speed);
		motor_left(left,speed);

		}

int motor_circle(int speed,int rad,int muki,int r,int l){
int rad_s,speed_s;
	sensor.stepflag=0;		
rad_s=rad-MIRS_RADIUS/2;
position_taihi=position;
position=((mirs.rot_r-r)*800)/TWO_PI;	
if(position<0){//ロータリエンコーダ通信エラー
position=position_taihi;
}
speed_s=rad_s*speed/(rad_s+MIRS_RADIUS);

		if(muki==RIGHT){
		motor_right('r',speed);
		motor_left('r',speed_s);
				}
		else if(muki==LEFT){
		motor_right('f',speed);
		motor_left('f',speed_s);
				}
return position;
}
/*int motor_circle(int speed,int rad,int muki,int r,int l){
int position=0;//position:一周800
float target_ratio=0,now_ratio=0;//position:一周800

target_ratio=(float)((rad+MIRS_RADIUS2)/(rad-MIRS_RADIUS/2));
if((mirs.rot_l-l)!=0){
now_ratio=(float)((mirs.rot_r-r)/(mirs.rot_l-l));
}else{
now_ratio=target_ratio;
}
position=(int)(400*(mirs.rot_r-r)/(rad+MIRS_RADIUS/2)/3.14);//θ=S/R=(mirs.rot_r-r)/(rad+MIRS_RADIUS/2)
		if(muki==RIGHT){
		
		}else if(muki==LEFT){
			if(now_ratio>target_ratio){
			motor_left('f',speed);	
			motor_right('b',0);	
			}else if(now_ratio<target_ratio){
			motor_right('f',speed);	
			motor_left('b',0);	
			}else{
			motor_right('f',speed);	
			motor_left('f',speed);	
			}
		}

return position;
}
*/


//回転中はセンサー監視動作を抑えるようにフラグを付けてパフォーマンスを高くしてみる予定

int turn_right(int speed,int rotang,int err){
	
	static int col_cnt;
	sensor.stepflag=0;
	
		if(turning==0){
			col_cnt=0;
			baseang=mirs.angle_now;
			turn_cnt=0;
			if(rotang%90==0)mirs.direction-=rotang;
		}

		if(mirs.rot_r==turn_old){
			turn_cnt++;
		}else{
			turn_cnt=0;			
		}
		if(turn_cnt>=6){
			turn_cnt=0;
			if(sensor.ts2==49 || sensor.ts3==49)motor_back(127);
			else{motor_forward(127);}
			usleep(250000);
			motor_stop2();
		}

		turn_old=mirs.rot_r;

		turning=1;
		
		int targetang=baseang-rotang;
if(turning_s==0){
		if(mirs.angle_now>targetang+20){
			motor_rotation(speed,RIGHT);
		}else if(mirs.angle_now<targetang-20){
			motor_rotation(speed,LEFT);
		}else{	
			motor_stop2();
			turning_s=1;
		}
}else if(turning_s==1){

		if(mirs.angle_now>=targetang+err){
			motor_rotation(speed,RIGHT);
			usleep(150000);
			motor_stop2();
		}else if(mirs.angle_now<=targetang-err){
			motor_rotation(speed,LEFT);
			usleep(150000);
			motor_stop2();
		}else{	
			motor_stop2();
			turning=0;
			turning_s=0;
			return 1;
		}
	
}
	return 0;
}


int turn_left(int speed,int rotang,int err){
	
	static int col_cnt;
	sensor.stepflag=0;		
		if(turning==0){
				col_cnt=0;
				baseang=mirs.angle_now;
				turn_cnt=0;			
				if(rotang%90==0)mirs.direction+=rotang;
		}
if(mirs.rot_r==turn_old){
		turn_cnt++;
		}else{
		turn_cnt=0;			
		}
		if(turn_cnt>=6){
			turn_cnt=0;
			if(sensor.ts2==49 || sensor.ts3==49)motor_back(127);
			else{motor_forward(127);}
			usleep(250000);
			motor_stop2();
		}
		turn_old=mirs.rot_r;

		turning=1;

		int targetang=baseang+rotang;

if(turning_s==0){
		if(mirs.angle_now<targetang-20){
			motor_rotation(speed,LEFT);
		}else if(mirs.angle_now>targetang+20){
			motor_rotation(speed,RIGHT);
		}else{
			motor_stop2();
			turning_s=1;
		}
}else if(turning_s==1){
		if(mirs.angle_now<=targetang-err){
			motor_rotation(speed,LEFT);
			usleep(150000);
			motor_stop2();
		}else if(mirs.angle_now>=targetang+err){
			motor_rotation(speed,RIGHT);
			usleep(150000);
			motor_stop2();
		}else{	
			motor_stop2();
			turning=0;
			turning_s=0;
			return 1;
		}
		
}
	return 0;
}

int motor_forward_dis(int speed,int rotdis,int err){

	sensor.stepflag=0;		

		if(forward==0){
		basedis_r=mirs.rot_r;
//		basedis_l=mirs.rot_l;
		}

		forward=1;
	
		int nowdis=mirs.rot_r;

		int targetdis_r=basedis_r+rotdis;
//		int targetdis_l=basedis_l+rotdis;

		if(nowdis<=targetdis_r-err){
			motor_forward(speed);
		}else if(nowdis>=targetdis_r+err){
			motor_back(speed);
		}else{
			motor_stop2();
			forward=0;
			forward_cnt=0;
			return 1;
		}
	
	forward_cnt++;
	
	return 0;
}

int motor_back_dis(int speed,int rotdis,int err){
	sensor.stepflag=0;		
if(motor_forward_dis(speed,-rotdis,err)){
	return 1;
}
return 0;
}

int colang,coldir;

int turn_collect(int speed,int err){
	sensor.stepflag=0;

	static int primdirection;
	
	int nowang;
	int cnt,sign;
	int ret;
	
	if(collecting==0){
		
		primdirection=mirs.direction;
		nowang=mirs.angle_now;	
		cnt=0;
		
		/*if(nowang>0)sign=1;
		else if(nowang<0)sign=-1;
		else{return 1;}
	
		while(1){
	
			if(abs(nowang-90*cnt*sign)<=45){
					colang=abs(nowang-90*cnt*sign);
					if(nowang-90*cnt*sign>err)coldir=RIGHT;
			   else if(nowang-90*cnt*sign<-err)coldir=LEFT;
					else{return 1;}
					break;
			}
			else{cnt++;}
		}*/
		
		//ここから追加部**********************************************************************
		
			 if(nowang-primdirection>err)coldir=RIGHT;
		else if(nowang-primdirection<-err)coldir=LEFT;
			else{return 1;}
		
		colang=abs(nowang-primdirection);
		
		//ここまで追加部**********************************************************************
		
		collecting=1;
	}
	
	if(coldir==RIGHT)ret=turn_right(speed,colang,err);
	else if(coldir==LEFT)ret=turn_left(speed,colang,err);
	
	if(ret==1){
		collecting=0;
		mirs.direction=primdirection;
		return 1;
	}
	
	return 0;
	
}

int touch_collect(int speed,int muki,int err){
	
	sensor.stepflag=0;

	static int collecting2=0,primdirection;
	static int primang,pilotang,prepang,dir,nextdir,sign,cnt=0;
	int ret=0;

	if(collecting2==0){//状況判断&計算
		
		ignws=1;
		primdirection=mirs.direction;
		primang=mirs.angle_now;
		
		cnt=0;
		
		if(primang>0)sign=1;
		else if(primang<0)sign=-1;
		//else{return 1;}
	
		while(1){
	
			if(abs(primang-90*cnt*sign)<=45){
					prepang=90*cnt*sign;
					break;
			}
			else{cnt++;}
		}
		
		if(muki==LEFT && (mirs.direction>primang)){
			pilotang=90-abs(prepang-primang);
			dir=RIGHT;
			nextdir=LEFT;
			collecting2=11;
			return 0;
		}
		else if(muki==RIGHT && (mirs.direction<primang)){
			pilotang=90-abs(prepang-primang);
			dir=LEFT;
			nextdir=RIGHT;
			collecting2=11;
			return 0;
		}

		if(prepang>primang){
			pilotang=45-(prepang-primang);
			dir=RIGHT;
			if(muki==RIGHT)nextdir=LEFT;
			else if(muki==LEFT)nextdir=RIGHT;
		}
		else if(prepang<primang){
			pilotang=45-(primang-prepang);
			dir=LEFT;
			if(muki==RIGHT)nextdir=LEFT;
			else if(muki==LEFT)nextdir=RIGHT;
		}
		else{
			if(muki==RIGHT){
			pilotang=45;
			dir=RIGHT;
			nextdir=LEFT;
			}
			else if(muki==LEFT){
			pilotang=45;
			dir=LEFT;
			nextdir=RIGHT;
			}
		}
		collecting2=1;
	}
	else if(collecting2==1){//ちょっと後退

		motor_back(50);
		usleep(300000);
		motor_stop2();
		collecting2=2;
	}
	else if(collecting2==2){//壁に対して45度になるように回転
	
		if(dir==RIGHT)ret=turn_right(speed,pilotang,err);
		else if(dir==LEFT)ret=turn_left(speed,pilotang,err);
		
		if(ret==1)collecting2=3;
	}
	else if(collecting2==3){//一定量後退

		motor_back(50);
		usleep(300000);
		motor_stop2();
		collecting2=4;
	}
	else if(collecting2==4){//正常な角度に戻す
	
		if(nextdir==RIGHT)ret=turn_right(speed,45,err);
		else if(nextdir==LEFT)ret=turn_left(speed,45,err);
		
		if(ret==1){
			//mirs.direction=primdirection;
			collecting2=0;
			ignws=0;
			mirs.direction=primdirection;
			return 1;
		}
	}
	else if(collecting2==11){
	
		motor_back(50);
		usleep(400000);
		motor_stop2();
		collecting2=12;
		
	}
	else if(collecting2==12){
		
		if(dir==RIGHT)ret=turn_right(speed,pilotang,err);
		else if(dir==LEFT)ret=turn_left(speed,pilotang,err);
		
		if(ret==1)collecting2=13;
	}
	else if(collecting2==13){//一定量前進

		motor_forward(50);
		usleep(400000);
		motor_stop2();
		collecting2=14;
	}
	else if(collecting2==14){//正常な角度に戻す
	
		if(nextdir==RIGHT)ret=turn_right(speed,90,err);
		else if(nextdir==LEFT)ret=turn_left(speed,90,err);
		
		if(ret==1){
			mirs.direction=primdirection;
			collecting2=0;
			ignws=0;
			colflag=0;
			return 1;
		}
	}
	/*else if(collecting==5){//基準角に合うように補正
	
		if(turn_collect(speed,err)){
		collecting2=0;
		return 1;
		}
	}*/
	return 0;
}
