#include <cv.h>
#include <highgui.h>
#include <cxcore.h>
#include <stdio.h>

#include "./include/CVdefine.h"
#include "./include/CVGV.h"

int labeling(IplImage *src,IplImage *dst1,IplImage *dst2,char *collect,int *centerpos){

	int label_kari[src->width+2][src->height+2];//1$B%T%/%;%kL\$H:G8e$N%T%/%;%k;~$K$=$l$>$l>e$N%T%/%;%k$H2<$N%T%/%;%k$r8+$k$N$G!"(B+2$BM>J,$KI,MW(B
	int label_true[src->width+2][src->height+2];
	int table[LABEL_MAX][2];	//[][0]$B$O85%G!<%?(B [][1]$B$OJQ49$9$Y$-%G!<%?(B
	int sousa[4]={0,0,0,0};
	int sousa_flag=0;
	int number=0,min=LABEL_MAX;
	int area[LABEL_MAX];
	int n=0;
	int area_temp[LABEL_MAX][2];
	int area_max=0,area_nmax=0,area_nnmax=0;;
	int max_num,nmax_num,nnmax_num;
	int x,y;//$B2hAGAv::MQ%k!<%WJQ?t(B
	int i;//$B%k!<%WMQJQ?t(B
	int harea_r=0,harea_l=0;

	int counter=0;

	//CvScalar bin;
	uchar bin;

	for(i=0;i<LABEL_MAX;i++){//$B%i%Y%kJQ49%F!<%V%k$N=i4|2=(B
				table[i][0]=i;
				table[i][1]=i;
				area[i]=0;
				}

	for(y=0;y<src->height;y++){
		for(x=0;x<src->width;x++){
			label_kari[x][y]=0;
			label_true[x][y]=0;
		}
	}

	for(y=0;y<src->height;y++){
		for(x=0;x<src->width;x++){

	bin=src->imageData[src->widthStep*y+x];
	//$B2hAG$XD>@\%"%/%;%9(B(cvGet(Set)Real2D$B$O=E$$$h$&$J$N$G(B)
			
			if(bin==255){
			
				if(x<(src->width/2))harea_l++;
				else{harea_r++;}
			
			}

		   if(bin==255 && label_kari[x][y]==0){//$B$b$7BP>]2hAG$J$i$P(B

					sousa_flag=0;
					min=LABEL_MAX;

					sousa[0]=label_kari[x-1][y];
					sousa[1]=label_kari[x-1][y-1];
					sousa[2]=label_kari[x][y-1];
					sousa[3]=label_kari[x+1][y-1];
					

				for(i=0;i<4;i++)sousa_flag+=sousa[i];

				if(sousa_flag==0){//$B$9$Y$F%i%Y%k$,$J$+$C$?$i(B
						number++;
						label_kari[x][y]=number;
						}
				else{//$B$I$l$+$K%i%Y%k$,$"$k$J$i(B
				    for(i=0;i<4;i++){
					if(sousa[i]<min && sousa[i]!=0){
							   min=sousa[i];
							}
						}
					label_kari[x][y]=min;

				for(i=0;i<4;i++){//$B%i%Y%k:FDj5A%k!<%A%s(B
					if(sousa[i]!=min && sousa[i]!=0){
						table[sousa[i]][1]=min;

					    while(1){
						if(table[min][1]!=min){
								min=table[min][1];
								table[sousa[i]][1]=min;
						}else{break;}
							}
						}
					}

				}

			}//$BBP>]2hA|$J$i$P$N=*$o$j(B
		}
	}

	for(y=0;y<src->height;y++){
		for(x=0;x<src->width;x++){

		label_true[x][y]=table[label_kari[x][y]][1];
		if(label_true[x][y]!=0)area[label_true[x][y]]++;//$BLL@Q$N%+%&%s%H(B
		else area[label_true[x][y]]=0;

		}
	}

	for(i=0;i<LABEL_MAX;i++){

		if(area[i]>IGNSIZE){
				area_temp[n][0]=area[i];//$B%U%#%k%?%j%s%08e$K;D$C$?LL@Q(B
				area_temp[n][1]=i;//$B$=$N;~$N%i%Y%kHV9f(B
				n++;
				}

	}

	
	for(i=0;i<n;i++){//$B:GBgLL@Q$N8!=P(B

		if(area_max<area_temp[i][0]){
					area_max=area_temp[i][0];
					max_num=area_temp[i][1];
		}

	}

	for(i=0;i<n;i++){//$B#2HVL\$KBg$-$$LL@Q$N8!=P(B

		if(area_nmax<area_temp[i][0] && area_temp[i][0]!=area_max){
					area_nmax=area_temp[i][0];
					nmax_num=area_temp[i][1];
		}

	}

	for(i=0;i<n;i++){//3$BHVL\$KBg$-$$LL@Q$N8!=P(B

		if(area_nnmax<area_temp[i][0] && area_temp[i][0]!=area_max && area_temp[i][0]!=area_nmax){
					area_nnmax=area_temp[i][0];
					nnmax_num=area_temp[i][1];
		}

	}
	
	int center_cntx=0,center_cnty=0,label_old=-1,cntsum=0,xend=0,endsum=0,center_pos,cntflag=0;
	int center[WINDOW_Y*(int)(WINDOW_X/6)];
	int arraycnt=0,near_min=9999,near_sub,near_x=0,truex,near_temp,truecnt=0,near_sum=0;
	int err;
	
	for(y=0;y<src->height;y++){
		center_cntx=0;
		label_old=-1;
		for(x=0;x<src->width;x++){
			if(label_true[x][y]==max_num){
				
				if(label_old!=max_num)cntflag=1;
				
				if(cntflag==1){
					center_cntx++;
				}
			}
			else{
				
				if(center_cntx<=30 && center_cntx>=7){//$BCf1{$N$7$-$j$NB@$5$N>l=j$@$1$r8!CN$9$k(B
					center[arraycnt]=x;
					arraycnt++;
					endsum+=x;
					cntsum+=center_cntx;
					center_cnty++;
				}
				
				cntflag=0;
				center_cntx=0;
			}
			label_old=label_true[x][y];
		}
	}
	
	if(center_cnty==0)center_cnty=160;
	
	for(i=0;i<arraycnt;i++){
		near_sub=abs(endsum/center_cnty-center[i]);
		if(near_sub<near_min){
			near_min=near_sub;
			near_x=center[i];
		}
	}
	
	for(i=0;i<arraycnt;i++){
		near_temp=abs(near_x-center[i]);
		if(near_temp<=50){
			truecnt++;
			near_sum+=center[i];
		}
	}
	
	if(truecnt==0)truecnt=160;
	
	truex=near_sum/truecnt;
	
	center_pos=truex-((cntsum/center_cnty)/2);
	
	*centerpos=center_pos;
	
	err=WINDOW_X/2;
	
	if(center_pos>err+5)*collect='R';
	else if(center_pos<err-5)*collect='L';
	else{*collect='F';}
	
	
	if(area_max==0 || area_nmax==0 || area_nnmax==0){
		return -1;	//OpenCV$B$N%(%i!<2sHr$N$?$a$K$3$3$G%(%i!<5/$-$k$+$I$&$+H=CG(B
	}


	for(x=0;x<src->width;x++){//$B%i%Y%k%$%a!<%8$N=i4|2=(B
		for(y=0;y<src->height;y++){
			dst1->imageData[dst1->widthStep*y+x]=0;
			dst2->imageData[dst2->widthStep*y+x]=0;
		}
	}


	for(y=0;y<src->height;y++){
		for(x=0;x<src->width;x++){
			if(label_true[x][y]==nmax_num)dst1->imageData[dst1->widthStep*y+x]=255;
		 else if(label_true[x][y]==nnmax_num)dst2->imageData[dst2->widthStep*y+x]=255;
		}
	}
	
}


void gettrim(IplImage *src,CvRect *rect){

	int x,y,x1,x2,y1,y2;
	IplImage *tempImage;
	uchar col;

		x1=-1,x2=-1,y1=-1,y2=-1;

			tempImage=cvCreateImage(cvGetSize(src),IPL_DEPTH_8U,1);
			tempImage=cvCloneImage(src);

		for(x=0;x<tempImage->width;x++){
			for(y=0;y<tempImage->height;y++){

			col=tempImage->imageData[tempImage->widthStep*y+x];

				if(col==255){
					x1=x;
					break;
				}
			}
			if(x==x1)break;
		}


		for(y=0;y<tempImage->height;y++){
			for(x=0;x<tempImage->width;x++){

			col=tempImage->imageData[tempImage->widthStep*y+x];

				if(col==255){
					y1=y;
					break;
				}
			}
			if(y==y1)break;
		}


		for(x=(tempImage->width)-1;x>=0;x--){
			for(y=(tempImage->height)-1;y>=0;y--){

			col=tempImage->imageData[tempImage->widthStep*y+x];

				if(col==255){
					x2=x;
					break;
				}
			}
			if(x==x2)break;
		}


		for(y=(tempImage->height)-1;y>=0;y--){
			for(x=(tempImage->width)-1;x>=0;x--){

			col=tempImage->imageData[tempImage->widthStep*y+x];

				if(col==255){
					y2=y;
					break;
				}
			}
			if(y==y2)break;
		}

		*rect=cvRect(x1,y1,x2-x1,y2-y1);

	cvReleaseImage(&tempImage);

	return;

}

void triming(IplImage *src,IplImage *dst,CvRect rect){

cvSetImageROI(src,rect);
cvCopy(src,dst,NULL);
cvResetImageROI(src);

	
	
}




